package com.intel;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import gov.niarl.his.webservices.hisPrivacyCAWebService2.IHisPrivacyCAWebService2;
import gov.niarl.his.webservices.hisPrivacyCAWebService2.client.HisPrivacyCAWebServices2ClientInvoker;

public class CreateIdentity {
    
    static String homeFolder = "/etc/intel/cloudsecurity/";
    static String socketClientIp = "";
    
    public static byte[] createIdentity() throws Exception{
        readPropertiesFile();
        byte[]  encryptedChallenge = "".getBytes();
        String PrivacyCaUrl ="https://" +socketClientIp +":8181/HisPrivacyCAWebServices2";
        IHisPrivacyCAWebService2 hisPrivacyCAWebService2 = HisPrivacyCAWebServices2ClientInvoker.getHisPrivacyCAWebService2(PrivacyCaUrl);
        byte[] aic=hisPrivacyCAWebService2.identityRequestSubmitResponse(encryptedChallenge);
        return aic;
    }
    
    private static void readPropertiesFile (){
        String propertiesFileName =  "hisprovisioner.properties";
        String SOCKET_CLIENT_IP = "socketClientIp";
        InputStream PropertyFile = null;
        try{
            PropertyFile = new FileInputStream(homeFolder +  propertiesFileName);
            Properties PrivacyCaProperties = new Properties();
            PrivacyCaProperties.load(PropertyFile);
            socketClientIp = PrivacyCaProperties.getProperty(SOCKET_CLIENT_IP, "127.0.0.1");
        } catch (FileNotFoundException e) {
            System.out.println("Error finding Privacy CA properties file: cannot continue. Please place properties file in: home folder." + homeFolder);
            System.out.println(e.toString());
        } catch (IOException e) {
            System.out.println("Error loading Privacy CA properties file: cannot continue." + homeFolder);
        }
        finally{
             try {
                 if (PropertyFile != null)
                     PropertyFile.close();
             } catch (IOException e) {
                e.printStackTrace();
             }
        }
    }
    
}
